using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Collections;

namespace InfraStructureLayer
{
    public class ExtendedDataTable:DataTable
    {

        public ExtendedDataTable():base()
        {
            
        }
        public ExtendedDataTable(DataTable dt)
            : base()
        {
            
        }

        private string _TableStyle;
        private string _HeaderStyle = "background-color:#075b98;color:#FFFFFF;padding-left:10px;font-weight:bold;height:25px;";
        private string _RowStyle = "background-color:#e1edfb;padding-left:10px;height:25px;";
        private string _AlternatingRowStyle = "background-color: #FFFFFF;padding-left:10px;height:25px;";
        private Hashtable _ColumnNames = new Hashtable();
        private Hashtable _ColumnAlignments = new Hashtable();
        private Hashtable _ColumnFormats = new Hashtable();

        public string TableStyle
        {
            get { return _TableStyle; }
            set { _TableStyle = value; }
        }
        public string HeaderStyle
        {
            get { return _HeaderStyle; }
            set { _HeaderStyle = value; }
        }
        public string RowStyle
        {
            get { return _RowStyle; }
            set { _RowStyle = value; }
        }
        public string AlternatingRowStyle
        {
            get { return _AlternatingRowStyle; }
            set { _AlternatingRowStyle = value; }
        }
        public Hashtable ColumnNames
        {
            get { return _ColumnNames; }
            set { _ColumnNames = value; }
        }
        public Hashtable ColumnAlignments
        {
            get { return _ColumnAlignments; }
            set { _ColumnAlignments = value; }
        }
        public Hashtable ColumnFormats
        {
            get { return _ColumnFormats; }
            set { _ColumnFormats = value; }
        }

        public string ToHTML()
        {
            try
            {
                int columnCount = 0;
                StringBuilder sb = new StringBuilder();
                sb.Append(@"<table style=""");
                sb.Append(TableStyle);
                sb.Append(@""">");
                sb.Append(@"<tr style=""");
                sb.Append(HeaderStyle);
                sb.Append(@""">");
                foreach (DataColumn dc in this.Columns)
                {
                    if (ColumnNames.Keys.Count == 0 || ColumnNames.ContainsKey(dc.ColumnName))
                    {
                        sb.Append("<td align=center>");
                        if (ColumnNames.Keys.Count == 0)
                        {
                            sb.Append(dc.ToString());
                        }
                        else if (ColumnNames.ContainsKey(dc.ColumnName))
                        {
                            sb.Append(ColumnNames[dc.ColumnName].ToString());
                        }
                        sb.Append("</td>");
                        columnCount++;
                    }

                }
                sb.Append("</tr>");
                if (this.Rows.Count > 0)
                {
                    for (int i = 0; i < this.Rows.Count; i++)
                    {
                        sb.Append(@"<tr style=""");
                        if (i % 2 == 0)
                        {
                            sb.Append(RowStyle);
                        }
                        else
                        {
                            sb.Append(AlternatingRowStyle);
                        }
                        sb.Append(@""">");
                        foreach (DataColumn dc in this.Columns)
                        {
                            if (ColumnNames.Keys.Count == 0 || ColumnNames.ContainsKey(dc.ColumnName))
                            {
                                sb.Append("<td");
                                if (ColumnAlignments.ContainsKey(dc.ColumnName))
                                {
                                    sb.Append(" align=");
                                    sb.Append(ColumnAlignments[dc.ColumnName].ToString());
                                }
                               
                                sb.Append(">");
                                if (ColumnFormats.ContainsKey(dc.ColumnName))
                                {
                                    sb.Append(String.Format(ColumnFormats[dc.ColumnName].ToString(), this.Rows[i][dc]));
                                }
                                else
                                {
                                    sb.Append(this.Rows[i][dc].ToString());
                                }
                                sb.Append("</td>");
                            }
                        }
                        sb.Append("</tr>");
                    }
                }
                else
                {
                    sb.Append("<tr><td colspan=" + columnCount.ToString() + ">Kayt Bulunamad</td></tr>");
                }
                
                sb.Append("</table>");

                return sb.ToString();
            }
            catch (Exception ex)
            {

            }
            return "Tablo Oluturulurken Hata";

        }
        public static string ToHTMLExternal(DataTable dt)
        {
            try
            {
                         string TableStyle="";
         string HeaderStyle = "background-color:#075b98;color:#FFFFFF;padding-left:10px;font-weight:bold;height:25px;";
         string RowStyle = "background-color:#e1edfb;padding-left:10px;height:25px;";
         string AlternatingRowStyle = "background-color: #FFFFFF;padding-left:10px;height:25px;";
                int columnCount = 0;
                StringBuilder sb = new StringBuilder();
                sb.Append(@"<table style=""");
                sb.Append(TableStyle);
                sb.Append(@""">");
                sb.Append(@"<tr style=""");
                sb.Append(HeaderStyle);
                sb.Append(@""">");
                foreach (DataColumn dc in dt.Columns)
                {
                        sb.Append("<td>");
                        
                            sb.Append(dc.ToString());
                            sb.Append("</td>");
                        columnCount++;
                }
                sb.Append("</tr>");
                if (dt.Rows.Count > 0)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {
                        sb.Append(@"<tr style=""");
                        if (i % 2 == 0)
                        {
                            sb.Append(RowStyle);
                        }
                        else
                        {
                            sb.Append(AlternatingRowStyle);
                        }
                        sb.Append(@""">");
                        foreach (DataColumn dc in dt.Columns)
                        {
                            sb.Append("<td>" + dt.Rows[i][dc].ToString() + "</td>");
                        }
                        sb.Append("</tr>");
                    }
                }
                else
                {
                    sb.Append("<tr><td colspan=" + columnCount.ToString() + ">Kayt Bulunamad</td></tr>");
                }

                sb.Append("</table>");

                return sb.ToString();
            }
            catch (Exception ex)
            {

            }
            return "Tablo Oluturulurken Hata";

        }
        public void ImportDataTable(DataTable dt)
        {
            this.Columns.Clear();
            this.Rows.Clear();
            foreach (DataColumn dc in dt.Columns)
            {
                this.Columns.Add(dc.ColumnName,dc.DataType);
            }
            foreach (DataRow dr in dt.Rows)
            {
                this.Rows.Add(dr.ItemArray);
            }
        }
    }
}
