using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.WebControls;

namespace WebControls
{
    public class SFRepeater : Repeater,IMultiLanguage
    {
        public void SetData(object parDataSource)
        {
            this.DataSource = parDataSource;
            this.DataBind();
        }
        public override void DataBind()
        {
            base.DataBind();
            ((SFPage)this.Page).SetLanguage(this);
        }
        public delegate bool NeedsDataSourceDelegate();

        public event NeedsDataSourceDelegate NeedsDataSource;
        public bool LoadRepeaterData()
        {
            if (NeedsDataSource != null)
            {
                return NeedsDataSource();
            }
            else
            {
                return false;
            }
        }

        #region IMultiLanguage Members

        public void SetControlLanguage()
        {
            this.LoadRepeaterData();
        }

        private bool _IsProtectedForLanguageChange = false;
        public bool IsProtectedForLanguageChange
        {
            get
            {
                return _IsProtectedForLanguageChange;
            }
            set
            {
                _IsProtectedForLanguageChange = value;
            }
        }

        private bool _IsMasterPageControl = false;
        public bool IsMasterPageControl
        {
            get
            {
                return _IsMasterPageControl;
            }
            set
            {
                _IsMasterPageControl = value;
            }
        }

        #endregion
    }
}
